
function paymill_response_handler(error, result) {
    if ( error || result.token.length < 1) {
        jQuery("#paymill_messages").show();
    } else {
        // Create the paymill token and submit the form
        jQuery('#paymill_token').remove();
        jQuery('form.checkout').append('<input type="hidden" name="paymill_token" id="paymill_token" value="'+result.token+'">');
        jQuery('form.checkout').submit();
    }
}

function paymill_repopulate(dummy, real) {
    if ( jQuery('#'+dummy).length > 0 ) {
        jQuery('#'+real).val(jQuery('#'+dummy).val());
    }
}

// Passes in the form
function paymill_process_checkout(dom_element) {

	// Set the cancel button, otherwise it defaults to German
	paymill.config( '3ds_cancel_label', wc_paymill.threeds_cancel_label );
    // Let WooCommerce submit the form if we have a token
    if ( jQuery ('#paymill_token').length > 0 ) {
        return true;
    }
    // Let WooCommerce submit the form if we have a payment ID selected
    if ( jQuery ('#paymill_payment_id').length > 0 && jQuery('#paymill_payment_id').val() != '' ) {
        return true;
    }
    // Otherwise, validate the details entered
    var paymill_validation_errors = 0;

    if ( ! paymill.validateCardNumber(jQuery('#paymill_card_number').val()) ) {
        paymill_validation_errors++;
        jQuery('#paymill_card_number').addClass('wc_paymill_error');
    } else {
        jQuery('#paymill_card_number').removeClass('wc_paymill_error');
    }

    if ( ! paymill.validateExpiry(jQuery('#paymill_card_expiry_month').val(), jQuery('#paymill_card_expiry_year').val()) ) {
        paymill_validation_errors++;
        jQuery('#paymill_card_expiry_month').addClass('wc_paymill_error');
        jQuery('#paymill_card_expiry_year').addClass('wc_paymill_error');
    } else {
        jQuery('#paymill_card_expiry_month').removeClass('wc_paymill_error');
        jQuery('#paymill_card_expiry_year').removeClass('wc_paymill_error');
    }

    if ( ! paymill.validateCvc(jQuery('#paymill_cvv').val()) ) {
        paymill_validation_errors++;
        jQuery('#paymill_cvv').addClass('wc_paymill_error');
    } else {
        jQuery('#paymill_cvv').removeClass('wc_paymill_error');
    }

    if ( jQuery('#paymill_cardholder').val().length < 1 ) {
        paymill_validation_errors++;
        jQuery('#paymill_cardholder').addClass('wc_paymill_error');
    } else {
        jQuery('#paymill_cardholder').removeClass('wc_paymill_error');
    }

    // If no validation errors, get a token
    if ( paymill_validation_errors == 0 ) {

        // Create token
        paymill.createToken({
            number: jQuery('#paymill_card_number').val(),
            exp_month: jQuery('#paymill_card_expiry_month').val(),
            exp_year: jQuery('#paymill_card_expiry_year').val(),
            cvc: jQuery('#paymill_cvv').val(),
            amount_int: jQuery('#paymill_order_total').val(),
            currency: PAYMILL_CURRENCY,
            cardholder: jQuery('#paymill_cardholder').val(),
            }, paymill_response_handler);

        // Don't let WooCommerce submit the form yet - the callback handler will do it
        return false;
    } else {
        // Validation errors
        jQuery("#paymill_messages").show();
        return false;
    }
}

jQuery(document).ready(function() {
    jQuery('form.checkout').on('checkout_place_order_paymill', function () {
        return paymill_process_checkout(this);
    });
    jQuery('body').on('updated_checkout', function () {
        // If we're re-loading the form then re-populate the credit card forms
        paymill_repopulate ( 'dummy_paymill_card_number', 'paymill_card_number' );
        paymill_repopulate ( 'dummy_paymill_cardholder', 'paymill_cardholder' );
        paymill_repopulate ( 'dummy_paymill_card_expiry_month', 'paymill_card_expiry_month' );
        paymill_repopulate ( 'dummy_paymill_card_expiry_year', 'paymill_card_expiry_year' );
        paymill_repopulate ( 'dummy_paymill_cvv', 'paymill_cvv' );
        jQuery('#paymill_payment_id').change();
    });
    // TODO - what's the equivalent on the overdue payment page
    jQuery('body').on('change', '#paymill_payment_id', function() {
        if ( jQuery('#paymill_payment_id').val() == '' ) {
            jQuery('#paymill_new_card_form').slideDown();
        } else {
            jQuery('#paymill_new_card_form').slideUp();
        }
    })
    jQuery('#paymill_payment_id').change();
});

jQuery(document).ready(function() {
    jQuery('form.checkout').on('change', '.paymill_checkout_field', function () {
        var dummy_name = 'dummy_'+(jQuery(this).attr('id'));
        // Invalidate the token
        jQuery('#paymill_token').remove();
        // Store the details in case the paymnt form gets refreshed
        jQuery('#'+dummy_name).remove();
        jQuery('#customer_details').append('<input type="hidden" id="'+dummy_name+'" value="'+jQuery(this).val()+'">');
    });
});
