<?php

/*
Plugin Name: WooCommerce Paymill Gateway
Plugin URI: https://woocommerce.com/products/paymill-gateway/
Description: WooCommerce payment gateway for processing payments through paymill.com
Version: 3.3.0
Author: Lee Willis
Author URI: http://plugins.leewillis.co.uk/

Copyright: © 2016 Ademti Software Ltd.
License: GNU General Public License v3.0
License URI: http://www.gnu.org/licenses/gpl-3.0.html

Built on the foundations of the PayPal Pro module © WooThemes
*/

/**
 * Required functions
 */
if ( ! function_exists( 'woothemes_queue_update' ) ) {
    require_once( 'woo-includes/woo-functions.php' );
}

/**
 * Plugin updates
 */
woothemes_queue_update( plugin_basename( __FILE__ ), '45314efa23a077567b706957e3fb7c3f', '184626' );

function woocommerce_paymill_init() {

    if ( ! class_exists( 'WC_Payment_Gateway' ) )
    	return;

    require_once ( 'woocommerce-paymill.class.php');

    /**
    * Localise
    **/
    load_plugin_textdomain ( 'wc_paymill', false, basename( dirname( __FILE__ ) ) . '/languages/' );

	/*	TODO - Subscription code
	if ( class_exists( 'WC_Subscriptions_Order' ) ) {
        include_once( 'woocommerce-paymill-subscriptions.php' );
        add_filter( 'woocommerce_subscriptions_renewal_order_meta_query', 'WC_Gateway_Paymill_Subscriptions::remove_renewal_order_meta', 10, 4 );
    }
    */

    /**
    * Add the Gateway to WooCommerce
    **/
	function woocommerce_paymill_add_gateway( $methods ) {

		/*	TODO - Subscription code
        if ( class_exists( 'WC_Subscriptions_Order' ) )
            $methods[] = 'WC_Gateway_Paymill_Subscriptions';
        else
        */
            $methods[] = 'WC_Gateway_Paymill';

        return $methods;

    }

    add_filter( 'woocommerce_payment_gateways', 'woocommerce_paymill_add_gateway' );
    add_action( 'woocommerce_before_my_account', 'wc_paymill_before_my_account' );

}

add_action( 'plugins_loaded', 'woocommerce_paymill_init' );



function wc_paymill_before_my_account() {
	new WC_Gateway_Paymill();
}



require_once( 'Paymill-API/lib/Services/Paymill/Clients.php' );
require_once( 'Paymill-API/lib/Services/Paymill/Transactions.php' );
require_once( 'Paymill-API/lib/Services/Paymill/Payments.php' );
require_once( 'Paymill-API/lib/Services/Paymill/Refunds.php' );
